#ifndef _EXPA_H
#define _EXPA_H

#undef SIXTY_FOUR_BIT

#define POS (1)
#define NEG (2)

#define XFLXSTART (NCOLS - NXFLX + 1)
#define BIT_TYPESIZE (sizeof(BIT_TYPE) * 8)
#define XTYPESIZE (sizeof(XTYPE) * 8)
#define MEMORY_THRESHOLD (0x800000)
#define INITIAL_MEMORY (0x80000)
#define MEMORY_INCREMENT (0x10000)

#define BIT_1  0x1

#ifdef SIXTY_FOUR_BIT
#define MAXBITS (0xffffffffffffffffUL)
#define BIT_64 (0x8000000000000000UL)
#define HIGH_BIT (BIT_64)
typedef long XTYPE;
typedef unsigned long BIT_TYPE;
#else
#define MAXBITS (0xffffffffUL)
#define BIT_32 (0x80000000UL)
#define HIGH_BIT (BIT_32)
typedef int XTYPE;
typedef unsigned int BIT_TYPE;
#endif
#define LOW_BIT (BIT_1)




typedef enum {
	my_false = 0, my_true
} BOOLEAN;

typedef enum {
	 FREE = 0, INPUT = -1, OUTPUT = 1
} XFLXTYPE;


typedef int INT32;
typedef unsigned int UINT32;












#ifdef _EXPA_C
	void readMatrix(XTYPE** m1Ptr, XTYPE** matEPtr, BIT_TYPE** bit1Ptr,
								XFLXTYPE* xPtr, char* file, char* xFile);
	void readMatrix2(XTYPE** m1Ptr, XTYPE** matEPtr, BIT_TYPE** bit1Ptr,
								XFLXTYPE* xPtr, XTYPE*** stoickMat);

	void readMatrix3(XTYPE*** m1PtrPtr, BIT_TYPE*** bit1PtrPtr, char* matFile);
	void makeColPtr(UINT32* colPtr, char* colFile, UINT32* numberOfCols);
	void computePathways(XTYPE*** mat1PtrPtr, XTYPE*** mat2PtrPtr, XTYPE** matEPtr, BIT_TYPE*** bit1PtrPtr, UINT32* newColumns,
								UINT32 numberOfNewColumns );
	UINT32 numberOfNz( BIT_TYPE *bPtr);	
	void makeBitArray(XTYPE* mPtr, BIT_TYPE* bArrayPtr);
	void printHelp(void);
	void reduceRows(XTYPE** matPtr, BIT_TYPE** bitPtr, UINT32 numberOfRows);
	UINT32 findColumn(BIT_TYPE** b1Ptr, XTYPE** m1Ptr, UINT32 qSize);
	UINT32 NROWS;
	UINT32 NCOLS;
	UINT32 NXFLX;
	UINT32 NUMBER_OF_XTYPES; 
	UINT32 NUMBER_OF_RESIDS; 
#else
	extern void readMatrix(XTYPE** m1Ptr, XTYPE** matEPtr, BIT_TYPE bit1Ptr, 
									XFLXTYPE* xPtr, char* file, char* xFile);
	extern void readMatrix2(XTYPE** m1Ptr, XTYPE** matEPtr, BIT_TYPE** bit1Ptr,
								XFLXTYPE* xPtr, XTYPE*** stoickMat);
	void readMatrix3(XTYPE*** m1PtrPtr, BIT_TYPE*** bit1PtrPtr, char* matFile);
	void makeColPtr(UINT32* colPtr, char* colFile, UINT32* numberOfCols);
	extern void computePathways(XTYPE*** mat1PtrPtr, XTYPE*** mat2PtrPtr, XTYPE** matEPtr, BIT_TYPE*** bit1PtrPtr, UINT32* newColumns,
								UINT32 numberOfNewColumns );
	extern UINT32 numberOfNz( BIT_TYPE *bPtr);
	extern void makeBitArray(XTYPE* mPtr, BIT_TYPE* bArrayPtr);
	extern printHelp(void);
	extern void reduceRows(XTYPE** matPtr, BIT_TYPE** bitPtr, UINT32 numberOfRows);
	extern UINT32 findColumn(BIT_TYPE** b1Ptr, XTYPE** m1Ptr, UINT32 qSize);
	extern UINT32 NROWS;
	extern UINT32 NCOLS;
	extern UINT32 NXFLX;
	extern UINT32 NUMBER_OF_XTYPES; 
	extern UINT32 NUMBER_OF_RESIDS; 
#endif



#endif /*end of file*/


